package pl.com.rszewczyk.common.security.api;

import lombok.extern.slf4j.Slf4j;
import org.springframework.core.MethodParameter;
import org.springframework.web.bind.ServletRequestBindingException;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.context.request.NativeWebRequest;
import org.springframework.web.method.annotation.AbstractNamedValueMethodArgumentResolver;
import pl.com.rszewczyk.common.api.support.domain.ApplicationType;

@Slf4j
public class ApplicationTypeMethodArgumentResolver extends AbstractNamedValueMethodArgumentResolver {
    /**
     * Used header is generated by ApplicationNameInjectorZuulFilter in gateway
     */
    private final static String HEADER_APPLICATION_NAME = ApplicationType.X_APPLICATION_NAME;

    @Override
    public boolean supportsParameter(MethodParameter parameter) {
        return parameter.nestedIfOptional().getNestedGenericParameterType().equals(ApplicationType.class)
                && parameter.getParameterAnnotation(RequestParam.class) == null;
    }

    @Override
    protected NamedValueInfo createNamedValueInfo(MethodParameter parameter) {
        return new ApplicationTypeMethodArgumentResolver.RequestHeaderNamedValueInfo();
    }

    @Override
    protected Object resolveName(String name, MethodParameter parameter, NativeWebRequest request) throws Exception {
        String[] headerValues = request.getHeaderValues(HEADER_APPLICATION_NAME);
        if (headerValues != null && headerValues.length > 0) {
            return ApplicationType.ofHeader(headerValues[0]).orElseGet(() -> {
                log.warn("Not supported header {} value: '{}' for method {}", name, headerValues[0], parameter.getMethod().getName());
                return ApplicationType.UNKNOWN;
            });
        } else {
            log.warn("Missing request header {} for method {}", name, parameter.getMethod().getName());
            return ApplicationType.UNKNOWN;
        }
    }

    @Override
    protected void handleMissingValue(String name, MethodParameter parameter) throws ServletRequestBindingException {
        throw new ServletRequestBindingException("Missing request header '" + name + "' for method parameter of type " + parameter.getNestedParameterType().getSimpleName());
    }

    private static class RequestHeaderNamedValueInfo extends NamedValueInfo {

        private RequestHeaderNamedValueInfo() {
            super(HEADER_APPLICATION_NAME, true, null);
        }
    }
}
